#
# === Synopsis:
#   RightScale RightPublish (right_publish) - (c) 2013 RightScale Inc
#

require 'mime/types'

module RightPublish
  # Combined list of MIME types that should be registered with mime-types, AND preferred
  # MIME types for this application to use, in cases where a given filename extension is
  # used by multiple MIME types.
  MIME_TYPES = {
    'application/x-deb'            => 'deb',
    'application/x-ruby-gem'       => 'gem',
    'application/x-rpm'            => 'rpm',
    'application/x-msi'            => 'msi',
    'text/xml'                     => 'xml',
  }
end

# Register some extra MIME types that the gem may not know about.
RightPublish::MIME_TYPES.each_pair do |name, extension|
  if MIME::Types[name].empty?
    type = MIME::Type.new(name) do |t|
      t.extensions = [extension]
      t.encoding = '8bit'
    end
    MIME::Types.add(type)
  end
end

require 'right_publish/profile'
require 'right_publish/annotation'
require 'right_publish/repo'
require 'right_publish/cli'
